<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: Class Hierarchy</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Class Hierarchy</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock">
<p><a href="hierarchy.html">Go to the textual class hierarchy</a></p>
</div><table border="0" cellspacing="10" cellpadding="0">
<tr><td><img src="inherit_graph_0.png" border="0" usemap="#CollisionVisitor" alt=""/>
<map name="CollisionVisitor" id="CollisionVisitor">
<area shape="rect" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter." alt="" coords="5,81,125,108"/>
<area shape="rect" href="classCollisionBonus.html" title="Resolves collision between Bonus and other objects." alt="" coords="183,5,302,32"/>
<area shape="rect" href="classCollisionEnemy.html" title="Resolves collision between Enemy and other objects." alt="" coords="181,56,304,83"/>
<area shape="rect" href="classCollisionPlayer.html" title="Resolves collision between Player and other objects." alt="" coords="183,107,302,133"/>
<area shape="rect" href="classCollisionProjectile.html" title="Resolves collision between Projectile and other objects." alt="" coords="173,157,312,184"/>
</map>
</td></tr>
<tr><td><img src="inherit_graph_1.png" border="0" usemap="#GameScene" alt=""/>
<map name="GameScene" id="GameScene">
<area shape="rect" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,..." alt="" coords="5,5,105,32"/>
</map>
</td></tr>
<tr><td><img src="inherit_graph_2.png" border="0" usemap="#LevelManager" alt=""/>
<map name="LevelManager" id="LevelManager">
<area shape="rect" href="classLevelManager.html" title="Mayer singlton class of LevelMagager which manages loading of level and spawning enemies." alt="" coords="5,5,120,32"/>
</map>
</td></tr>
<tr><td><img src="inherit_graph_3.png" border="0" usemap="#Menu" alt=""/>
<map name="Menu" id="Menu">
<area shape="rect" href="classMenu.html" title="Menu class for managing user input." alt="" coords="5,5,64,32"/>
</map>
</td></tr>
<tr><td><img src="inherit_graph_4.png" border="0" usemap="#Object" alt=""/>
<map name="Object" id="Object">
<area shape="rect" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce..." alt="" coords="5,233,69,260"/>
<area shape="rect" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties." alt="" coords="117,233,220,260"/>
<area shape="rect" href="classBonus.html" title="Abstract class representing bonuses that can be applied to Player." alt="" coords="278,107,341,133"/>
<area shape="rect" href="classEntity.html" title="Abstract class representing GameObjects that have weapon and health." alt="" coords="279,233,339,260"/>
<area shape="rect" href="classProjectile.html" title="class representing projectiles with their own speed, damage and sprites" alt="" coords="268,360,351,387"/>
<area shape="rect" href="classCannonBonus.html" title="Cannon weapon bonus." alt="" coords="415,5,525,32"/>
<area shape="rect" href="classHealBonus.html" title="Health repairing bonus." alt="" coords="424,56,516,83"/>
<area shape="rect" href="classMachineGunBonus.html" title="MachineGun weapon bonus." alt="" coords="399,107,541,133"/>
<area shape="rect" href="classRocketBonus.html" title="RocketLauncher weapon bonus." alt="" coords="417,157,523,184"/>
<area shape="rect" href="classEnemy.html" title="Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death." alt="" coords="437,208,503,235"/>
<area shape="rect" href="classPlayer.html" title="Represent player, takes user input." alt="" coords="439,259,501,285"/>
<area shape="rect" href="classBomber.html" title="Basic enemy with rocker launcher." alt="" coords="589,132,663,159"/>
<area shape="rect" href="classCruiser.html" title="High health high fire rate enemy, cannot move while firing has cooldown on fire." alt="" coords="592,183,660,209"/>
<area shape="rect" href="classDrone.html" title="Fast low health enemy, bounces off borders." alt="" coords="595,233,657,260"/>
<area shape="rect" href="classFighter.html" title="Basic enemy with machinegun." alt="" coords="593,284,659,311"/>
<area shape="rect" href="classBullet.html" title="Bullet projectile with ability to bounce off borders." alt="" coords="440,309,500,336"/>
<area shape="rect" href="classMiniRocket.html" title="MiniRocket mini projectile supplementing Rocket projectile." alt="" coords="423,360,517,387"/>
<area shape="rect" href="classRocket.html" title="Rocket projectile balanced big projectile." alt="" coords="437,411,503,437"/>
<area shape="rect" href="classShell.html" title="Cannon projectile fast and hard hitting." alt="" coords="443,461,497,488"/>
</map>
</td></tr>
<tr><td><img src="inherit_graph_5.png" border="0" usemap="#ScoreManager" alt=""/>
<map name="ScoreManager" id="ScoreManager">
<area shape="rect" href="classScoreManager.html" title="Mayer singlton class of ScoreManager which saves and loads scores." alt="" coords="5,5,120,32"/>
</map>
</td></tr>
<tr><td><img src="inherit_graph_6.png" border="0" usemap="#SpawnData" alt=""/>
<map name="SpawnData" id="SpawnData">
<area shape="rect" href="structSpawnData.html" title="Struct to store data from level file." alt="" coords="5,5,101,32"/>
</map>
</td></tr>
<tr><td><img src="inherit_graph_7.png" border="0" usemap="#Weapon" alt=""/>
<map name="Weapon" id="Weapon">
<area shape="rect" href="classWeapon.html" title="Factory styled class for creating projectiles." alt="" coords="5,56,80,83"/>
<area shape="rect" href="classCannon.html" title="Cannon slow firing high damage weapon." alt="" coords="155,5,226,32"/>
<area shape="rect" href="classMachineGun.html" title="MachineGun starter weapon with ability to bounce bullets off borders." alt="" coords="139,56,242,83"/>
<area shape="rect" href="classRocketLauncher.html" title="RocketLauncher balanced weapon with direct fire." alt="" coords="128,107,253,133"/>
</map>
</td></tr>
</table>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
